
#include "at24c04.h"

at24c04 eeprom(0x20);                             // Адрес девайса

#define PM_ADDR 0x1D                              //Адрес Power Mode Profile
#define PM_DATA 0x02                              //Режим РМ (РМ2)
#define CONFIG_ADDR 0x1E                          //Адрес Power Mode Profile configuration
#define CONFIG_DATA 0x05                          //Конфигурация (B>B>A) 


int pm = 0;                                           //Режим РМ
int conf = 0;                                         //конфиг
//---------------------------------------------------------------------------------------------------------
void setup() {
  
  pinMode(LED_BUILTIN, OUTPUT);
  eeprom.init();
  SMCR = 0b00000101;                             // Режим Power Down
  ADCSRA &= ~(1 << ADEN);                        //  ADC switch off
}
//---------------------------------------------------------------------------------------------------------
void loop() {
  

        blinka();      // поморгали и видно что запустилось, заодно пауза на переходной процесс усилителя.
               
        eeprom_write();  // записали настройки
        
        // проверка как записалось        
        PM_ADDR_read();    // читаем РМ
        if (pm == PM_DATA) {
        // если данные совпали, проверяем конфиг
        
        CONFIG_ADDR_read();    // читаем конфиг
        if (conf == CONFIG_DATA) {
        // если данные совпали моргаем короткими 8 сек
        blinkc();         
        
                       }
               else {
                     // не сравнилось, тогда моргаем до ребута
                     blinkb();
              }
        } 
        
        // уходим в спячку
        register byte temp = MCUCR | 1 << BODS;        // Управление отключением BOD (детектор пониженного напряжения питания)
        MCUCR |= 1 << BODSE;                           // Разрешение записи в BODS
        MCUCR = temp;                                  // Разрешение спящего режима BOD
        __asm__ volatile ("sleep\n\t");                // Sleep CPU + BOD + ADC switch off
  
}

//---------------------------------------------------------------------------------------------------------
void PM_ADDR_read() {
      uint8_t read_byte = eeprom.read(PM_ADDR);
      pm = read_byte;
}
//---------------------------------------------------------------------------------------------------------
void CONFIG_ADDR_read() {
      uint8_t read_byte1 = eeprom.read(CONFIG_ADDR);
      conf = read_byte1;
}      
//---------------------------------------------------------------------------------------------------------
void eeprom_write() {
    eeprom.update(PM_ADDR, PM_DATA);
    eeprom.update(CONFIG_ADDR, CONFIG_DATA);
}
//---------------------------------------------------------------------------------------------------------
void blinka() {        
        // моргалка и пауза в 5 сек  
        for (int i = 0; i <= 2; i++) {
    digitalWrite(LED_BUILTIN, HIGH);   // гори
    delay(1000);
    digitalWrite(LED_BUILTIN, LOW);    // тухни
    delay(1000);
  }
        
}
//---------------------------------------------------------------------------------------------------------
void blinkb() {        
     flash:    
        digitalWrite(LED_BUILTIN, HIGH);   // гори
        delay(200);                       // 0,2сек
        digitalWrite(LED_BUILTIN, LOW);    // тухни
        delay(200);                       
        goto flash;
}
//---------------------------------------------------------------------------------------------------------
void blinkc() {        
        // короткая моргалка
        for (int f = 0; f <= 10; f++) {
    digitalWrite(LED_BUILTIN, HIGH);   // гори
    delay(100);
    digitalWrite(LED_BUILTIN, LOW);    // тухни
    delay(1000);
        }          
}
